# This file was automatically generated by SWIG (http://www.swig.org).
# Version 4.0.2
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.

"""
UTL module, see official documentation at
https://www.opencascade.com/doc/occt-7.6.0/refman/html/package_utl.html
"""

from sys import version_info as _swig_python_version_info
if _swig_python_version_info < (2, 7, 0):
    raise RuntimeError("Python 2.7 or later required")

# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _UTL
else:
    import _UTL

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "thisown":
            self.this.own(value)
        elif name == "this":
            set(self, name, value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


class SwigPyIterator(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _UTL.delete_SwigPyIterator

    def value(self) -> "PyObject *":
        return _UTL.SwigPyIterator_value(self)

    def incr(self, n: "size_t"=1) -> "swig::SwigPyIterator *":
        return _UTL.SwigPyIterator_incr(self, n)

    def decr(self, n: "size_t"=1) -> "swig::SwigPyIterator *":
        return _UTL.SwigPyIterator_decr(self, n)

    def distance(self, x: "SwigPyIterator") -> "ptrdiff_t":
        return _UTL.SwigPyIterator_distance(self, x)

    def equal(self, x: "SwigPyIterator") -> "bool":
        return _UTL.SwigPyIterator_equal(self, x)

    def copy(self) -> "swig::SwigPyIterator *":
        return _UTL.SwigPyIterator_copy(self)

    def next(self) -> "PyObject *":
        return _UTL.SwigPyIterator_next(self)

    def __next__(self) -> "PyObject *":
        return _UTL.SwigPyIterator___next__(self)

    def previous(self) -> "PyObject *":
        return _UTL.SwigPyIterator_previous(self)

    def advance(self, n: "ptrdiff_t") -> "swig::SwigPyIterator *":
        return _UTL.SwigPyIterator_advance(self, n)

    def __eq__(self, x: "SwigPyIterator") -> "bool":
        return _UTL.SwigPyIterator___eq__(self, x)

    def __ne__(self, x: "SwigPyIterator") -> "bool":
        return _UTL.SwigPyIterator___ne__(self, x)

    def __iadd__(self, n: "ptrdiff_t") -> "swig::SwigPyIterator &":
        return _UTL.SwigPyIterator___iadd__(self, n)

    def __isub__(self, n: "ptrdiff_t") -> "swig::SwigPyIterator &":
        return _UTL.SwigPyIterator___isub__(self, n)

    def __add__(self, n: "ptrdiff_t") -> "swig::SwigPyIterator *":
        return _UTL.SwigPyIterator___add__(self, n)

    def __sub__(self, *args) -> "ptrdiff_t":
        return _UTL.SwigPyIterator___sub__(self, *args)
    def __iter__(self):
        return self

# Register SwigPyIterator in _UTL:
_UTL.SwigPyIterator_swigregister(SwigPyIterator)


def _dumps_object(klass):
    """ Overwrite default string output for any wrapped object.
    By default, __repr__ method returns something like:
    <OCC.Core.TopoDS.TopoDS_Shape; proxy of <Swig Object of type 'TopoDS_Shape *' at 0x02BB0758> >
    This is too much verbose.
    We prefer :
    <class 'gp_Pnt'>
    or
    <class 'TopoDS_Shape'>
    """
    klass_name = str(klass.__class__).split(".")[3].split("'")[0]
    repr_string = "<class '" + klass_name + "'"
# for TopoDS_Shape, we also look for the base type
    if klass_name == "TopoDS_Shape":
        if klass.IsNull():
            repr_string += ": Null>"
            return repr_string
        st = klass.ShapeType()
        types = {OCC.Core.TopAbs.TopAbs_VERTEX: "Vertex",
                 OCC.Core.TopAbs.TopAbs_SOLID: "Solid",
                 OCC.Core.TopAbs.TopAbs_EDGE: "Edge",
                 OCC.Core.TopAbs.TopAbs_FACE: "Face",
                 OCC.Core.TopAbs.TopAbs_SHELL: "Shell",
                 OCC.Core.TopAbs.TopAbs_WIRE: "Wire",
                 OCC.Core.TopAbs.TopAbs_COMPOUND: "Compound",
                 OCC.Core.TopAbs.TopAbs_COMPSOLID: "Compsolid"}
        repr_string += "; Type:%s" % types[st]        
    elif hasattr(klass, "IsNull"):
        if klass.IsNull():
            repr_string += "; Null"
    repr_string += ">"
    return repr_string


def process_exception(error: "Standard_Failure", method_name: "std::string", class_name: "std::string") -> "void":
    return _UTL.process_exception(error, method_name, class_name)

from six import with_metaclass
import warnings
from OCC.Wrapper.wrapper_utils import Proxy, deprecated

import OCC.Core.Standard
import OCC.Core.NCollection
import OCC.Core.Storage
import OCC.Core.TCollection
import OCC.Core.OSD
import OCC.Core.Resource

from enum import IntEnum
from OCC.Core.Exception import *



class utl(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    @staticmethod
    def AddToUserInfo(*args) -> "void":
        r"""
        No available documentation.

        Parameters
        ----------
        aData: Storage_Data
        anInfo: TCollection_ExtendedString

        Returns
        -------
        None

        """
        return _UTL.utl_AddToUserInfo(*args)

    @staticmethod
    def CString(*args) -> "char const *":
        r"""
        No available documentation.

        Parameters
        ----------
        anExtendedString: TCollection_ExtendedString

        Returns
        -------
        char *

        """
        return _UTL.utl_CString(*args)

    @staticmethod
    def Disk(*args) -> "TCollection_ExtendedString":
        r"""
        No available documentation.

        Parameters
        ----------
        aPath: OSD_Path

        Returns
        -------
        TCollection_ExtendedString

        """
        return _UTL.utl_Disk(*args)

    @staticmethod
    def ExtendedString(*args) -> "TCollection_ExtendedString":
        r"""
        No available documentation.

        Parameters
        ----------
        anAsciiString: TCollection_AsciiString

        Returns
        -------
        TCollection_ExtendedString

        """
        return _UTL.utl_ExtendedString(*args)

    @staticmethod
    def Extension(*args) -> "TCollection_ExtendedString":
        r"""
        No available documentation.

        Parameters
        ----------
        aPath: OSD_Path

        Returns
        -------
        TCollection_ExtendedString
        No available documentation.

        Parameters
        ----------
        aFileName: TCollection_ExtendedString

        Returns
        -------
        TCollection_ExtendedString

        """
        return _UTL.utl_Extension(*args)

    @staticmethod
    def FileIterator(*args) -> "OSD_FileIterator":
        r"""
        No available documentation.

        Parameters
        ----------
        aPath: OSD_Path
        aMask: TCollection_ExtendedString

        Returns
        -------
        OSD_FileIterator

        """
        return _UTL.utl_FileIterator(*args)

    @staticmethod
    def Find(*args) -> "Standard_Boolean":
        r"""
        No available documentation.

        Parameters
        ----------
        aResourceManager: Resource_Manager
        aResourceName: TCollection_ExtendedString

        Returns
        -------
        bool

        """
        return _UTL.utl_Find(*args)

    @staticmethod
    def GUID(*args) -> "Standard_GUID":
        r"""
        No available documentation.

        Parameters
        ----------
        anXString: TCollection_ExtendedString

        Returns
        -------
        Standard_GUID

        """
        return _UTL.utl_GUID(*args)

    @staticmethod
    def IntegerValue(*args) -> "Standard_Integer":
        r"""
        No available documentation.

        Parameters
        ----------
        anExtendedString: TCollection_ExtendedString

        Returns
        -------
        int

        """
        return _UTL.utl_IntegerValue(*args)

    @staticmethod
    def IsReadOnly(*args) -> "Standard_Boolean":
        r"""
        No available documentation.

        Parameters
        ----------
        aFileName: TCollection_ExtendedString

        Returns
        -------
        bool

        """
        return _UTL.utl_IsReadOnly(*args)

    @staticmethod
    def LocalHost(*args) -> "TCollection_ExtendedString":
        r"""
        No available documentation.

        Returns
        -------
        TCollection_ExtendedString

        """
        return _UTL.utl_LocalHost(*args)

    @staticmethod
    def Name(*args) -> "TCollection_ExtendedString":
        r"""
        No available documentation.

        Parameters
        ----------
        aPath: OSD_Path

        Returns
        -------
        TCollection_ExtendedString

        """
        return _UTL.utl_Name(*args)

    @staticmethod
    def OpenFile(*args) -> "Storage_Error":
        r"""
        No available documentation.

        Parameters
        ----------
        aFile: Storage_BaseDriver
        aName: TCollection_ExtendedString
        aMode: Storage_OpenMode

        Returns
        -------
        Storage_Error

        """
        return _UTL.utl_OpenFile(*args)

    @staticmethod
    def Path(*args) -> "OSD_Path":
        r"""
        No available documentation.

        Parameters
        ----------
        aFileName: TCollection_ExtendedString

        Returns
        -------
        OSD_Path

        """
        return _UTL.utl_Path(*args)

    @staticmethod
    def Trek(*args) -> "TCollection_ExtendedString":
        r"""
        No available documentation.

        Parameters
        ----------
        aPath: OSD_Path

        Returns
        -------
        TCollection_ExtendedString

        """
        return _UTL.utl_Trek(*args)

    @staticmethod
    def Value(*args) -> "TCollection_ExtendedString":
        r"""
        No available documentation.

        Parameters
        ----------
        aResourceManager: Resource_Manager
        aResourceName: TCollection_ExtendedString

        Returns
        -------
        TCollection_ExtendedString

        """
        return _UTL.utl_Value(*args)

    @staticmethod
    def xgetenv(*args) -> "TCollection_ExtendedString":
        r"""
        No available documentation.

        Parameters
        ----------
        aCString: char *

        Returns
        -------
        TCollection_ExtendedString

        """
        return _UTL.utl_xgetenv(*args)

    __repr__ = _dumps_object


    def __init__(self):
        _UTL.utl_swiginit(self, _UTL.new_utl())
    __swig_destroy__ = _UTL.delete_utl

# Register utl in _UTL:
_UTL.utl_swigregister(utl)

def utl_AddToUserInfo(*args) -> "void":
    r"""
    No available documentation.

    Parameters
    ----------
    aData: Storage_Data
    anInfo: TCollection_ExtendedString

    Returns
    -------
    None

    """
    return _UTL.utl_AddToUserInfo(*args)

def utl_CString(*args) -> "char const *":
    r"""
    No available documentation.

    Parameters
    ----------
    anExtendedString: TCollection_ExtendedString

    Returns
    -------
    char *

    """
    return _UTL.utl_CString(*args)

def utl_Disk(*args) -> "TCollection_ExtendedString":
    r"""
    No available documentation.

    Parameters
    ----------
    aPath: OSD_Path

    Returns
    -------
    TCollection_ExtendedString

    """
    return _UTL.utl_Disk(*args)

def utl_ExtendedString(*args) -> "TCollection_ExtendedString":
    r"""
    No available documentation.

    Parameters
    ----------
    anAsciiString: TCollection_AsciiString

    Returns
    -------
    TCollection_ExtendedString

    """
    return _UTL.utl_ExtendedString(*args)

def utl_Extension(*args) -> "TCollection_ExtendedString":
    r"""
    No available documentation.

    Parameters
    ----------
    aPath: OSD_Path

    Returns
    -------
    TCollection_ExtendedString
    No available documentation.

    Parameters
    ----------
    aFileName: TCollection_ExtendedString

    Returns
    -------
    TCollection_ExtendedString

    """
    return _UTL.utl_Extension(*args)

def utl_FileIterator(*args) -> "OSD_FileIterator":
    r"""
    No available documentation.

    Parameters
    ----------
    aPath: OSD_Path
    aMask: TCollection_ExtendedString

    Returns
    -------
    OSD_FileIterator

    """
    return _UTL.utl_FileIterator(*args)

def utl_Find(*args) -> "Standard_Boolean":
    r"""
    No available documentation.

    Parameters
    ----------
    aResourceManager: Resource_Manager
    aResourceName: TCollection_ExtendedString

    Returns
    -------
    bool

    """
    return _UTL.utl_Find(*args)

def utl_GUID(*args) -> "Standard_GUID":
    r"""
    No available documentation.

    Parameters
    ----------
    anXString: TCollection_ExtendedString

    Returns
    -------
    Standard_GUID

    """
    return _UTL.utl_GUID(*args)

def utl_IntegerValue(*args) -> "Standard_Integer":
    r"""
    No available documentation.

    Parameters
    ----------
    anExtendedString: TCollection_ExtendedString

    Returns
    -------
    int

    """
    return _UTL.utl_IntegerValue(*args)

def utl_IsReadOnly(*args) -> "Standard_Boolean":
    r"""
    No available documentation.

    Parameters
    ----------
    aFileName: TCollection_ExtendedString

    Returns
    -------
    bool

    """
    return _UTL.utl_IsReadOnly(*args)

def utl_LocalHost(*args) -> "TCollection_ExtendedString":
    r"""
    No available documentation.

    Returns
    -------
    TCollection_ExtendedString

    """
    return _UTL.utl_LocalHost(*args)

def utl_Name(*args) -> "TCollection_ExtendedString":
    r"""
    No available documentation.

    Parameters
    ----------
    aPath: OSD_Path

    Returns
    -------
    TCollection_ExtendedString

    """
    return _UTL.utl_Name(*args)

def utl_OpenFile(*args) -> "Storage_Error":
    r"""
    No available documentation.

    Parameters
    ----------
    aFile: Storage_BaseDriver
    aName: TCollection_ExtendedString
    aMode: Storage_OpenMode

    Returns
    -------
    Storage_Error

    """
    return _UTL.utl_OpenFile(*args)

def utl_Path(*args) -> "OSD_Path":
    r"""
    No available documentation.

    Parameters
    ----------
    aFileName: TCollection_ExtendedString

    Returns
    -------
    OSD_Path

    """
    return _UTL.utl_Path(*args)

def utl_Trek(*args) -> "TCollection_ExtendedString":
    r"""
    No available documentation.

    Parameters
    ----------
    aPath: OSD_Path

    Returns
    -------
    TCollection_ExtendedString

    """
    return _UTL.utl_Trek(*args)

def utl_Value(*args) -> "TCollection_ExtendedString":
    r"""
    No available documentation.

    Parameters
    ----------
    aResourceManager: Resource_Manager
    aResourceName: TCollection_ExtendedString

    Returns
    -------
    TCollection_ExtendedString

    """
    return _UTL.utl_Value(*args)

def utl_xgetenv(*args) -> "TCollection_ExtendedString":
    r"""
    No available documentation.

    Parameters
    ----------
    aCString: char *

    Returns
    -------
    TCollection_ExtendedString

    """
    return _UTL.utl_xgetenv(*args)





